//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "Server.h"
//#include "playerstatus.h"
#include <iostream>

using namespace std;

#define debug(x) {cerr<<__FILE__<<": "<<__LINE__<<": "<<x<<endl;}
//#define debug(x)

Server::Server(int port)
    :acceptThread(0)
{
    // try given port
    if (!startServer(port))
    {
        // try any port
        if (!startServer(0))
        {
            // exit, because we still can't get a server up and running
            exit(-1);
        }
    }
}

Server::~Server()
{
}

bool Server::startServer(int port)
{
    /*
    debug("startServer() on port: " << port);
    try
    {
        Address serverAddress(Address::ANY_IP, port, false);
        open(Socket::TCP);
        setsockopt(SocketOption::ReuseAddr(1));
        bind(serverAddress);
        listen(5);
        return true;
    }
    catch (Exception& error)
    {
        std::cerr << "ERROR: Couldn't start server: " << 
            error.getMessage() << std::endl;
        return false;
    }
    */
    return true;
}

void Server::acceptClients()
{
    debug("acceptClients()");
    acceptThread = SDL_CreateThread(&acceptClientsThread, this);
}

void Server::stopAcceptingClients()
{
    if (acceptThread != 0)
    {
        SDL_KillThread(acceptThread);
    }
}

int Server::acceptClientsThread(void* data)
{
    /*
    Server* server = (Server*)data;
    while (true)
    {
        Address clientAddress;
        Socket connection = server->accept(clientAddress);
        debug("clientAddress: " << clientAddress.getPort());
        server->clientList.push_back(connection);
        SDL_CreateThread(&listenClientThread, server);
    }
    */
    return 0;
}

int Server::listenClientThread(void* data)
{
    /*
    Server* server = (Server*)data;
    StringBuffer recData(1024);
    server->clientList.back().recv(recData);
    std::cout << "received text = " << std::string(recData) << std::endl;
    */
    return 0;
}

// End of file
